﻿Public Class CLXread_write

    Dim readInProcess As Boolean = False

    Private Sub SimpleCLXSyncReadWrite_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
    Private Sub ReadPLC()

        'this is an example of read data from the COntrolLogix PLC as Int or Word data Type
        If readInProcess = True Then
            Exit Sub
        End If

        readInProcess = True

        Dim ReadValue(100) As Short     'returned data from read in array
        Dim resp As Short
        Dim address As String
        Dim readsize As Short
        ' Dim addr As Integer

        readsize = CShort(TextBox6.Text) 'Optional- Number registers to read, defaults to 1
        address = TextBox5.Text 'PLC reg address


        Label11.Text = ""
        'read plc and wait for response
        ' resp = FinScom1.ReadCLxTCP(address, ReadValue, readsize)

        resp = FinScom1.ReadCLxUDP(address, ReadValue, readsize)


        TextBox1.Text = CStr(ReadValue(1))
        TextBox2.Text = CStr(ReadValue(2))
        TextBox3.Text = CStr(ReadValue(3))
        TextBox4.Text = CStr(ReadValue(4))


        If resp = True Then
            Label11.Text = "Good resp"
        Else
            Label11.Text = "Bad resp"
        End If

        readInProcess = False

    End Sub

    Private Sub ReadPLCbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadPLCbtn.Click
        ReadPLC()


    End Sub

    Private Sub WritePLCbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WritePLCbtn.Click
        WritePLC()
    End Sub
    Private Sub WritePLC()
        'write data to PLC

        Dim address As String
        Dim valu(10) As Short  'vaule to write
        Dim resp As Short
        Dim Writesize As Short = TextBox7.Text  '2  '1

        address = Text1.Text
        valu(1) = (Text4.Text)
        valu(2) = (Text5.Text)

        resp = FinScom1.WriteCLxUDP(address, valu, Writesize)


        If resp <> True Then
            Label11.Text = "Bad resp"
        Else
            Label11.Text = "Good resp"

        End If

    End Sub
    Private Sub WriteFloat()
        'write data to PLC

        Dim address As String
        Dim valu(10) As Single    'value to write
        Dim resp As Short
        Dim Writesize As Short = TextBox7.Text  '1  'TextBox7.Text  '2  '1

        address = Text1.Text
        valu(1) = (Text4.Text)
        valu(2) = (Text5.Text)

        resp = FinScom1.WriteCLxUDP(address, valu, Writesize)
        ' resp = FinScom1.WriteCLxTCP(address, valu, Writesize)

        If resp <> True Then
            Label11.Text = "Bad resp"
        Else
            Label11.Text = "Good resp"

        End If



    End Sub
    Private Sub WriteString()

        'write data to PLC

        Dim address As String
        Dim valStr As String   'string to write
        Dim resp As Short
        Dim Writesize As Short = 1  'TextBox7.Text  '2  '1

        address = Text1.Text
        valStr = (Text4.Text)

        resp = FinScom1.WriteCLxUDP(address, valStr, Writesize)

        If resp <> True Then
            Label11.Text = "Bad resp"
        Else
            Label11.Text = "Good resp"

        End If



    End Sub

    Private Sub OpenPortBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenPortBtn.Click
        FinScom1.UDPconnect()   '.TCPconnect()

    End Sub

    Private Sub ReadFloatbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadFloatbtn.Click


        Dim ReadValue(10) As Single 'returned data from read in array

        Dim resp As Short
        Dim address As String
        Dim readsize As Short

        readsize = CShort(TextBox6.Text) 'Optional- Number registers to read, defaults to 1
        address = TextBox5.Text 'PLC reg address


        Label11.Text = ""
        'read plc and wait for response
        resp = FinScom1.ReadCLxUDP(address, ReadValue, readsize)
        ' resp = FinScom1.ReadCLxTCP(address, ReadValue, readsize)

        TextBox1.Text = CStr(ReadValue(1))
        TextBox2.Text = CStr(ReadValue(2))
        TextBox3.Text = CStr(ReadValue(3))
        TextBox4.Text = CStr(ReadValue(4))


        If resp = True Then
            Label11.Text = "Good resp"
        Else
            Label11.Text = "Bad resp"
        End If

        ' ReadFloat()
    End Sub

    Private Sub ReadStrBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadStrBtn.Click

        'this is an example of read data from the PLC
        Dim resp As Short
        Dim address As String
        Dim readsize As Short

        Dim ReadValueStr As String = ""  'returned vaalue as string

        readsize = CShort(TextBox6.Text) 'Optional- Number registers to read, defaults to 1
        address = TextBox5.Text 'PLC reg address


        Label11.Text = ""

        'read plc and wait for response
        resp = FinScom1.ReadCLxUDP(address, ReadValueStr, readsize)


        TextBox1.Text = CStr(ReadValueStr)


        If resp = True Then
            Label11.Text = "Good resp"
        Else
            Label11.Text = "Bad resp"
        End If

        'ReadString()
    End Sub

    Private Sub WriteFloatbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteFloatbtn.Click
        WriteFloat()
    End Sub

    Private Sub WriteStrbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteStrbtn.Click
        WriteString()
    End Sub

    Private Sub ReadBooleanbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadBooleanbtn.Click

        'this is an example of read data from the PLC
        Dim ReadValue(100) As Boolean  'Byte  'or use boolean for true  /false returned values

        Dim resp As Short
        Dim address As String
        Dim readsize As Short

        readsize = CShort(TextBox6.Text) 'Optional- Number registers to read, defaults to 1
        address = TextBox5.Text 'PLC reg address


        Label11.Text = ""
        'read plc and wait for response
        ' resp = FinScom1.ReadCLxTCP(address, ReadValue, readsize)
        resp = FinScom1.ReadCLxUDP(address, ReadValue, readsize)

        TextBox1.Text = CStr(ReadValue(1))
        TextBox2.Text = CStr(ReadValue(2))
        TextBox3.Text = CStr(ReadValue(3))
        TextBox4.Text = CStr(ReadValue(4))


        If resp = True Then
            Label11.Text = "Good resp"
        Else
            Label11.Text = "Bad resp"
        End If

    End Sub

    Private Sub ReadDWord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadDWord.Click

        'this is an example of read data from the PLC
        Dim ReadValue(100) As Integer  'integer in vb.net is 4 bytes or 32 bits

        Dim resp As Short
        Dim address As String
        Dim readsize As Short


        readsize = CShort(TextBox6.Text) 'Optional- Number registers to read, defaults to 1
        address = TextBox5.Text 'PLC reg address


        Label11.Text = ""
        'read plc and wait for response
        resp = FinScom1.ReadCLxUDP(address, ReadValue, readsize)
        'resp = FinScom1.ReadCLxTCP(address, ReadValue, readsize)

        TextBox1.Text = CStr(ReadValue(1))
        TextBox2.Text = CStr(ReadValue(2))
        TextBox3.Text = CStr(ReadValue(3))
        TextBox4.Text = CStr(ReadValue(4))


        If resp = True Then
            Label11.Text = "Good resp"
        Else
            Label11.Text = "Bad resp"
        End If

    End Sub

    Private Sub WriteBoolBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteBoolBtn.Click
        'write data to PLC

        Dim address As String
        'Dim valu(10) As Byte
        Dim valu(10) As Boolean

        Dim resp As Short
        Dim Writesize As Short = 1  'TextBox7.Text  '2  '1

        address = Text1.Text
        valu(1) = (Text4.Text)  '1 or 0

        resp = FinScom1.WriteCLxUDP(address, valu, Writesize)

        If resp <> True Then
            Label11.Text = "Bad resp"
        Else
            Label11.Text = "Good resp"

        End If


    End Sub

    Private Sub WriteDWordBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteDWordBtn.Click
        'write data to PLC

        Dim address As String
        Dim valu(10) As Integer
        Dim resp As Short
        Dim Writesize As Short = TextBox7.Text   '1   'TextBox7.Text  '2  '1

        address = Text1.Text
        valu(1) = (Text4.Text)
        valu(2) = (Text5.Text)

        resp = FinScom1.WriteCLxUDP(address, valu, Writesize)

        If resp <> True Then
            Label11.Text = "Bad resp"
        Else
            Label11.Text = "Good resp"

        End If


    End Sub

    Private Sub AbComTCP1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub AbComTCP1_Load_1(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        FinScom1.TCPClose()

    End Sub

    Private Sub Timer1_Elapsed(sender As System.Object, e As System.Timers.ElapsedEventArgs) Handles Timer1.Elapsed
        ReadPLC()
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Timer1.Interval = TextBox8.Text
        Timer1.Enabled = True

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        ' Timer1.Interval = TextBox8.Text

        Timer1.Enabled = False
    End Sub
End Class